summaryrefslogtreecommitdiff
path: root/tests/basic
blob: 9844454543b53d42f525e150ec5587b123c421af (plain)
  1. #!/usr/bin/env bash
  2. # Tests to ensure that the monkeysphere is working
  3. # Authors:
  4. # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
  5. # Jameson Rollins <jrollins@fifthhorseman.net>
  6. # Micah Anderson <micah@riseup.net>
  7. #
  8. # Copyright: 2008-2009
  9. # License: GPL v3 or later
  10. # these tests should all be able to run as a non-privileged user.
  11. # all subcommands in this script should complete without failure:
  12. set -e
  13. # piped commands should return the code of the first non-zero return
  14. set -o pipefail
  15. # make sure the TESTDIR is an absolute path, not a relative one.
  16. export TESTDIR=$(cd $(dirname "$0") && pwd)
  17. source "$TESTDIR"/common
  18. ## make sure that the right tools are installed to run the test. the
  19. ## test has *more* requirements than plain ol' monkeysphere:
  20. which socat >/dev/null || { echo "You must have socat installed to run this test." ; exit 1; }
  21. ## FIXME: other checks?
  22. ######################################################################
  23. ### FUNCTIONS
  24. # gpg command for test admin user
  25. gpgadmin() {
  26. chmod 0700 "$TEMPDIR"/admin
  27. GNUPGHOME="$TEMPDIR"/admin/.gnupg gpg "$@"
  28. }
  29. # test ssh connection
  30. # first argument is expected return code from ssh connection
  31. ssh_test() {
  32. umask 0077
  33. CODE=${1:-0}
  34. # start the ssh daemon on the socket
  35. echo "##### starting ssh server..."
  36. socat EXEC:"/usr/sbin/sshd -f ${SSHD_CONFIG} -i -D -e" "UNIX-LISTEN:${SOCKET}" 2> "$TEMPDIR"/sshd.log &
  37. SSHD_PID="$!"
  38. # wait until the socket is created before continuing
  39. while [ ! -S "$SOCKET" ] ; do
  40. sleep 1
  41. done
  42. set +e
  43. # make a client connection to the socket
  44. echo "##### starting ssh client..."
  45. ssh-agent bash -c \
  46. "monkeysphere subkey-to-ssh-agent && ssh -F $TEMPDIR/testuser/.ssh/config testhost true"
  47. RETURN="$?"
  48. # kill the sshd process if it's still running
  49. kill "$SSHD_PID"
  50. SSHD_PID=
  51. set -e
  52. echo "##### return $RETURN"
  53. if [ "$RETURN" = "$CODE" ] ; then
  54. echo "##### ssh connection test returned as desired"
  55. return 0
  56. else
  57. echo "##### ssh connection test failed. expected return code $CODE"
  58. return 1
  59. fi
  60. }
  61. SSHD_PID=
  62. ## setup trap
  63. trap failed_cleanup EXIT
  64. ######################################################################
  65. ### SETUP VARIABLES
  66. ## set up some variables to ensure that we're operating strictly in
  67. ## the tests, not system-wide:
  68. # set up temp dir
  69. # NOTE: /tmp can not be used as the temp dir here, since the
  70. # permissions on /tmp are usually such that they will not pass the
  71. # monkeysphere/ssh path permission checking. If you need to use a
  72. # different location than the current source, please set $TMPDIR
  73. # somewhere with tighter permissions.
  74. mkdir -p "$TESTDIR"/tmp
  75. TEMPDIR=$(mktemp -d "${TMPDIR:-$TESTDIR/tmp}/monkeyspheretest.XXXXXXX")
  76. # Use the local copy of executables first, instead of system ones.
  77. # This should help us test without installing.
  78. export PATH="$TESTDIR"/../src:"$TESTDIR"/../src/keytrans:"$PATH"
  79. export MONKEYSPHERE_SYSDATADIR="$TEMPDIR"
  80. export MONKEYSPHERE_SYSCONFIGDIR="$TEMPDIR"
  81. export MONKEYSPHERE_SYSSHAREDIR="$TESTDIR"/../src/share
  82. export MONKEYSPHERE_MONKEYSPHERE_USER=$(whoami)
  83. export MONKEYSPHERE_CHECK_KEYSERVER=false
  84. export MONKEYSPHERE_LOG_LEVEL=DEBUG
  85. export MONKEYSPHERE_CORE_KEYLENGTH=1024
  86. export SSHD_CONFIG="$TEMPDIR"/sshd_config
  87. export SOCKET="$TEMPDIR"/ssh-socket
  88. # Make sure $DISPLAY is set to convince ssh and monkeysphere to fall
  89. # back on $SSH_ASKPASS. Make sure it's not set to the current actual
  90. # $DISPLAY (if one exists) because this test suite should not be doing
  91. # *anything* with any running X11 session.
  92. export DISPLAY=monkeys
  93. ######################################################################
  94. ### CONFIGURE ENVIRONMENTS
  95. # copy in admin and testuser home to tmp
  96. echo "##################################################"
  97. echo "### configuring testuser home..."
  98. cp -a "$TESTDIR"/home/testuser "$TEMPDIR"/
  99. # set up environment for testuser
  100. export TESTHOME="$TEMPDIR"/testuser
  101. export GNUPGHOME="$TESTHOME"/.gnupg
  102. chmod 0700 "$GNUPGHOME"
  103. export SSH_ASKPASS="$TESTHOME"/.ssh/askpass
  104. export MONKEYSPHERE_HOME="$TESTHOME"/.monkeysphere
  105. cat <<EOF >> "$TESTHOME"/.ssh/config
  106. UserKnownHostsFile $TESTHOME/.ssh/known_hosts
  107. IdentityFile $TESTHOME/.ssh/no-such-identity
  108. ProxyCommand $TESTHOME/.ssh/proxy-command %h %p $SOCKET
  109. EOF
  110. cat <<EOF >> "$MONKEYSPHERE_HOME"/monkeysphere.conf
  111. KNOWN_HOSTS=$TESTHOME/.ssh/known_hosts
  112. EOF
  113. get_gpg_prng_arg >> "$GNUPGHOME"/gpg.conf
  114. echo "##################################################"
  115. echo "### configuring admin home..."
  116. cp -a "$TESTDIR"/home/admin "$TEMPDIR"/
  117. # set up sshd
  118. echo "##################################################"
  119. echo "### configuring sshd..."
  120. cp "$TESTDIR"/etc/ssh/sshd_config "$SSHD_CONFIG"
  121. # write the sshd_config
  122. cat <<EOF >> "$SSHD_CONFIG"
  123. HostKey ${MONKEYSPHERE_SYSDATADIR}/ssh_host_rsa_key
  124. AuthorizedKeysFile ${MONKEYSPHERE_SYSDATADIR}/authentication/authorized_keys/%u
  125. EOF
  126. ######################################################################
  127. ### SERVER HOST SETUP
  128. # import host key
  129. echo "##################################################"
  130. echo "### testing host key importing..."
  131. ssh-keygen -b 1024 -t rsa -N '' -f "$TEMPDIR"/ssh_host_rsa_key
  132. monkeysphere-host expert import-key testhost < "$TEMPDIR"/ssh_host_rsa_key
  133. # change host key expiration
  134. echo "##################################################"
  135. echo "### setting host key expiration..."
  136. monkeysphere-host set-expire 1
  137. # FIXME: how do we check that the expiration has really been set?
  138. echo "##################################################"
  139. echo "### getting host key fingerprint..."
  140. HOSTKEYID=$( monkeysphere-host show-key | grep '^OpenPGP fingerprint: ' | cut -f3 -d\ )
  141. echo "$HOSTKEYID"
  142. # certify host key with the "Admin's Key".
  143. # (this would normally be done via keyservers)
  144. echo "##################################################"
  145. echo "### certifying server host key..."
  146. GNUPGHOME="$MONKEYSPHERE_SYSCONFIGDIR"/host gpg --armor --export "$HOSTKEYID" | gpgadmin --import
  147. echo y | gpgadmin --command-fd 0 --sign-key "$HOSTKEYID"
  148. # FIXME: add revoker?
  149. # FIXME: how can we test publish-key without flooding junk into the
  150. # keyservers?
  151. # FIXME: should we run "diagnostics" here to test setup?
  152. ######################################################################
  153. ### SERVER AUTHENTICATION SETUP
  154. # set up monkeysphere authentication
  155. echo "##################################################"
  156. echo "### setup monkeysphere authentication..."
  157. cp "$TESTDIR"/etc/monkeysphere/monkeysphere-authentication.conf "$TEMPDIR"/
  158. cat <<EOF >> "$TEMPDIR"/monkeysphere-authentication.conf
  159. AUTHORIZED_USER_IDS="$MONKEYSPHERE_HOME/authorized_user_ids"
  160. EOF
  161. monkeysphere-authentication setup
  162. get_gpg_prng_arg >> "$MONKEYSPHERE_SYSDATADIR"/authentication/sphere/gpg.conf
  163. # add admin as identity certifier for testhost
  164. echo "##################################################"
  165. echo "### adding admin as certifier..."
  166. monkeysphere-authentication add-id-certifier -y "$TEMPDIR"/admin/.gnupg/pubkey.gpg
  167. echo "##################################################"
  168. echo "### list certifiers..."
  169. monkeysphere-authentication list-certifiers
  170. # FIXME: should we run "diagnostics" here to test setup?
  171. ######################################################################
  172. ### TESTUSER SETUP
  173. # generate an auth subkey for the test user that expires in 2 days
  174. echo "##################################################"
  175. echo "### generating key for testuser..."
  176. monkeysphere gen-subkey --expire 2
  177. # add server key to testuser keychain
  178. echo "##################################################"
  179. echo "### export server key to testuser..."
  180. gpgadmin --armor --export "$HOSTKEYID" | gpg --import
  181. # teach the "server" about the testuser's key
  182. echo "##################################################"
  183. echo "### export testuser key to server..."
  184. gpg --export testuser | monkeysphere-authentication expert gpg-cmd --import
  185. # update authorized_keys for user
  186. echo "##################################################"
  187. echo "### update server authorized_keys file for this testuser..."
  188. monkeysphere-authentication update-users $(whoami)
  189. # FIXME: NOT FAILING PROPERLY FOR:
  190. # ms: improper group or other writability on path '/tmp'.
  191. ######################################################################
  192. ### TESTS
  193. # connect to test sshd, using monkeysphere ssh-proxycommand to verify
  194. # the identity before connection. This should work in both directions!
  195. echo "##################################################"
  196. echo "### ssh connection test for success..."
  197. ssh_test
  198. # remove the testuser's authorized_user_ids file, update, and make
  199. # sure that the ssh authentication FAILS
  200. echo "##################################################"
  201. echo "### removing testuser authorized_user_ids and updating..."
  202. mv "$TESTHOME"/.monkeysphere/authorized_user_ids{,.bak}
  203. monkeysphere-authentication update-users $(whoami)
  204. echo "##################################################"
  205. echo "### ssh connection test for server authentication denial..."
  206. ssh_test 255
  207. mv "$TESTHOME"/.monkeysphere/authorized_user_ids{.bak,}
  208. # put improper permissions on authorized_user_ids file, update, and
  209. # make sure ssh authentication FAILS
  210. echo "##################################################"
  211. echo "### setting group writability on authorized_user_ids and updating..."
  212. chmod g+w "$TESTHOME"/.monkeysphere/authorized_user_ids
  213. monkeysphere-authentication update-users $(whoami)
  214. echo "##################################################"
  215. echo "### ssh connection test for server authentication denial..."
  216. ssh_test 255
  217. chmod g-w "$TESTHOME"/.monkeysphere/authorized_user_ids
  218. echo "##################################################"
  219. echo "### setting other writability on authorized_user_ids and updating..."
  220. chmod o+w "$TESTHOME"/.monkeysphere/authorized_user_ids
  221. monkeysphere-authentication update-users $(whoami)
  222. echo "##################################################"
  223. echo "### ssh connection test for server authentication denial..."
  224. ssh_test 255
  225. chmod o-w "$TESTHOME"/.monkeysphere/authorized_user_ids
  226. # FIXME: addtest: remove admin as id-certifier and check ssh failure
  227. # FIXME: addtest: add hostname on host key
  228. # FIXME: addtest: revoke hostname on host key and check ssh failure
  229. # FIXME: addtest: revoke the host key and check ssh failure
  230. ######################################################################
  231. trap - EXIT
  232. echo "##################################################"
  233. echo " Monkeysphere basic tests completed successfully!"
  234. echo "##################################################"
  235. cleanup